; drag.s

	GET	macros.s

window_handle	*	8
window		*	148

	IMPORT	|_3dstatus|

	AREA	|__drag_stuff|, COMMON, NOINIT

|__drag_callroutine|
	DCD	0
|__drag_lastdrag|
	DCD	0
|__drag_canvas|
	DCD	0
|__drag_nullcall|
	DCD	0

	AREA	|____drag_canvas|, CODE, READONLY
	EXPORT	drag_canvas
drag_canvas

; r0 is canvas
	STMFD	r13!,{r4-r6,lr}
	SUB	r13,r13,#24
	ADD	r1,r13,#4

	LDR	r0,[r0,#window_handle]
	STR	r0,[r1]
	SWI	XWimp_GetWindowOutline
	MOV	r1,r13
	LDR	r0,[r1,#4]
	STR	r0,[r1]
	MOV	r0,#1
	STR	r0,[r1,#4]
	SWI	XWimp_DragBox

	ADD	r13,r13,#24
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____drag_outline|, CODE, READONLY
	EXPORT	drag_outline
drag_outline

	IMPORT	draw_maxx
	IMPORT	draw_maxy
	IMPORT	main_addhandler
	IMPORT	icon_createforgetful

; r0 is canvas
; r1 is x size
; r2 is y size
; r3 is flag (0=limit to canvas, 1=limit to screen)
; r4 is routine to call when finished

	MOV	r12,r13
	STMFD	r13!,{r4-r7,lr}
	MOV	r7,r0
	MOV	r6,r1
	MOV	r5,r2
	LDR	r6,[r7,#window_handle]
	STR	r6,[r0,#window]!
	MOV	r6,r1
	MOV	r1,r0
	SWI	XWimp_GetWindowState
	ADD	r1,r1,#36
	SWI	XWimp_GetPointerInfo
	LDR	r2,[r1,#4]
	LDR	r0,[r1]
	SUB	r0,r0,r6,LSR#1
	STR	r0,[r1,#8]
	ADD	r0,r0,r6
	STR	r0,[r1,#16]
	SUB	r2,r2,r5,LSR#1
	STR	r2,[r1,#12]
	ADD	r2,r2,r5
	STR	r2,[r1,#20]
	TEQ	r3,#0
	BNE	drg_limitscreen
	SUB	r0,r1,#36
	LDMIB	r0,{r2-r5}
drg_return
	ADD	r0,r1,#24
	STMIA	r0,{r2-r5}
	MOV	r0,#5
	STR	r0,[r1,#4]
	SWI	XWimp_DragBox
 [ arm32
	LDMVSFD	r13!,{r4-r7,pc}
 |
	LDMVSFD	r13!,{r4-r7,pc}^
 ]
	LDR	r4,=|__drag_callroutine|
	LDR	r5,[r12]
	STR	r5,[r4]
	MOV	r0,#handler_drag
	LDR	r1,=drag_handler
	BL	main_addhandler
	STR	r0,[r4,#4]					; Store old handler
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

drg_limitscreen
	RSB	r2,r6,#0
	RSB	r3,r5,#0
	LDR	r4,=draw_maxx
	LDMIA	r4,{r4,r5}
	SUB	r4,r4,r2,ASR#1
	SUB	r5,r5,r3,ASR#1
	MOV	r2,r2,ASR#1
	MOV	r3,r3,ASR#1
	B	drg_return

	LTORG

	AREA	|____drag_hidden|, CODE, READONLY
	EXPORT	drag_hidden
drag_hidden

; r0 is canvas
; r1 is flag (0=limit to canvas, 1=limit to screen)
; r2 is routine to call when finished
; r3 is routine to call while dragging

	STMFD	r13!,{r2-r7,lr}
	LDR	r5,=|__drag_canvas|
	STMIA	r5,{r0,r3}
	MOV	r5,r1
	MOV	r7,r0
	LDR	r6,[r7,#window_handle]
	STR	r6,[r0,#window]!
	MOV	r1,r0
	SWI	XWimp_GetWindowState
	ADD	r1,r1,#36
	SWI	XWimp_GetPointerInfo
	LDR	r2,[r1,#4]
	LDR	r0,[r1]
	STR	r0,[r1,#8]
	STR	r0,[r1,#16]
	STR	r2,[r1,#12]
	STR	r2,[r1,#20]
	TEQ	r5,#0
	BNE	drgh_limitscreen
	SUB	r0,r1,#36
	LDMIB	r0,{r2-r5}
drgh_return
	ADD	r0,r1,#24
	STMIA	r0,{r2-r5}
	MOV	r0,#7
	STR	r0,[r1,#4]
	SWI	XWimp_DragBox
 [ arm32
	LDMVSFD	r13!,{r2-r7,pc}
 |
	LDMVSFD	r13!,{r2-r7,pc}^
 ]
	LDR	r4,=|__drag_callroutine|
	LDR	r5,[r13]
	STR	r5,[r4]
	MOV	r0,#handler_drag
	LDR	r1,=drag_handler
	BL	main_addhandler
	STR	r0,[r4,#4]					; Store old handler
	LDMFD	r13!,{r2-r7,lr}
	B	drgh_setimmediate

drgh_limitscreen
	MOV	r2,#0
	MOV	r3,#0
	LDR	r4,=draw_maxx
	LDMIA	r4,{r4,r5}
	B	drgh_return

drgh_nullroutine
	TEQ	r0,#0
	BNE	drgh_setimmediate
	STMFD	r13!,{r4,lr}
	LDR	r0,=|__drag_canvas|
	LDMIA	r0,{r1,r4}
	LDR	r0,[r1,#window_handle]
	STR	r0,[r1,#window]!
	SWI	XWimp_GetWindowState
	LDR	r0,[r1,#4]
	LDR	r2,[r1,#20]
	SUB	r2,r0,r2
	LDR	r0,[r1,#16]
	LDR	r3,[r1,#24]
	SUB	r3,r0,r3
	SWI	XWimp_GetPointerInfo
	LDR	r0,[r1,#8]
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}	; Released...
 |
	LDMEQFD	r13!,{r4,pc}^	; Released...
 ]
	LDMIA	r1,{r0,r1}
	SUB	r0,r0,r2
	SUB	r1,r1,r3
	TEQ	r4,#0
	MOV	lr,pc
	MOVNE	pc,r4
	LDMFD	r13!,{r4,lr}
drgh_setimmediate
	ADR	r1,drgh_nullroutine
	MOV	r0,#handler_immediate
	B	main_addhandler

	AREA	|____drag_handler|, CODE, READONLY
	EXPORT	drag_handler
drag_handler

	STMFD	r13!,{r4,r5,lr}
	LDR	r4,=|__drag_callroutine|
	LDR	r5,[r4]
	TST	r5,#1<<28
	BNE	dh_nosprite
	SWI	XDragASprite_Stop
dh_nosprite
	TEQ	r5,#0
	BEQ	drag_release
; Something
	SWI	XWimp_GetPointerInfo
	MOV	r0,r1
	MOV	lr,pc
	MOV	pc,r5
drag_release
	LDR	r1,[r4,#4]
	MOV	r0,#handler_drag
	BL	main_addhandler
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	LTORG

	AREA	|____drag_spriteicon|, CODE, READONLY
	EXPORT	drag_spriteicon
drag_spriteicon

	STMFD	r13!,{r2,r4-r7,lr}
	LDR	r2,[r0,#window_handle]
	STR	r2,[r0,#window]!
	STR	r1,[r0,#4]
	MOV	r1,r0
	SWI	XWimp_GetIconState
	ADD	r0,r1,#8
	LDR	lr,[r1,#8+24]					; Get validation string
	ADD	lr,lr,#1
	LDMIA	r0,{r4-r7}
	SWI	XWimp_GetWindowState
	LDR	r2,[r1,#20]
	LDR	r3,[r1,#4]
	SUB	r3,r3,r2
	ADD	r4,r4,r3
	ADD	r6,r6,r3
	LDR	r2,[r1,#24]
	LDR	r3,[r1,#16]
	SUB	r3,r3,r2
	ADD	r5,r5,r3
	ADD	r7,r7,r3
	MOV	r3,r1
	STMIA	r3,{r4-r7}
	MOV	r0,#2_11000101
	MOV	r1,#1
	MOV	r2,lr
	SWI	XDragASprite_Start
	LDR	r4,=|__drag_callroutine|
	LDR	r2,[r13]
	ORR	r2,r2,#1<<31
	STR	r2,[r4]
	MOV	r0,#handler_drag
	LDR	r1,=drag_handler
	BL	main_addhandler
	STR	r0,[r4,#4]					; Store old handler
 [ arm32
	LDMFD	r13!,{r2,r4-r7,pc}
 |
	LDMFD	r13!,{r2,r4-r7,pc}^
 ]

	LTORG

	AREA	|____drag_outlineicon|, CODE, READONLY
	EXPORT	drag_outlineicon
drag_outlineicon

	STMFD	r13!,{r2,r4-r7,lr}
	LDR	r2,[r0,#window_handle]
	STR	r2,[r0,#window]!
	STR	r1,[r0,#4]
	MOV	r1,r0
	SWI	XWimp_GetIconState
	ADD	r0,r1,#8
	LDMIA	r0,{r4-r7}
	SWI	XWimp_GetWindowState
	LDR	r2,[r1,#20]
	LDR	r3,[r1,#4]
	SUB	r3,r3,r2
	ADD	r4,r4,r3
	ADD	r6,r6,r3
	LDR	r2,[r1,#24]
	LDR	r3,[r1,#16]
	SUB	r3,r3,r2
	ADD	r5,r5,r3
	ADD	r7,r7,r3
	ADD	r3,r1,#8
	STMIA	r3!,{r4-r7}
	MOV	r4,#0
	MOV	r5,#0
	LDR	r0,=draw_maxx
	LDMIA	r0,{r6,r7}
	STMIA	r3,{r4-r7}
	MOV	r0,#5
	STR	r0,[r1,#4]
	SWI	XWimp_DragBox
	LDR	r4,=|__drag_callroutine|
	LDR	r2,[r13]
	STR	r2,[r4]
	MOV	r0,#handler_drag
	LDR	r1,=drag_handler
	BL	main_addhandler
	STR	r0,[r4,#4]					; Store old handler
 [ arm32
	LDMFD	r13!,{r2,r4-r7,pc}
 |
	LDMFD	r13!,{r2,r4-r7,pc}^
 ]

	LTORG

	AREA	saveas_texts, DATA
	EXPORT	saveas_savetxt
	EXPORT	saveas_canceltxt
	EXPORT	saveas_savevalidtxt
	EXPORT	saveas_cancelvalidtxt
	EXPORT	saveas_filevalidtxt
	EXPORT	saveas_iconflag
	EXPORT	saveas_badsavetxt

saveas_dsbox
	%	16

saveas_savetxt
	=	"Save",0,0,0,0
	DCD	0
saveas_canceltxt
	=	"Cancel",0,0
	DCD	0
saveas_savevalidtxt
	DCD	0,0,0
saveas_cancelvalidtxt
	DCD	0,0,0
saveas_filevalid
	=	0,"a~ ;"
saveas_filevalidtxt
	ALIGN
	DCD	0,0
saveas_iconflag
	DCD	&c71f913d
saveas_badsavetxt
	=	"To save, drag the icon to a directory viewer",0
	%	64
	ALIGN
saveas_stickyfield
	%	4

	IMPORT	option_valid
	IMPORT	radio_valid

;saveas_optionvalidt
;	=	"Soptoff,opton",0
;	ALIGN
saveas_ticon
	DCD	0,option_valid,12

;saveas_optionvalidu
;	=	"Sradiooff,radioon",0
;	ALIGN
saveas_uicon
	DCD	0,radio_valid,12

	AREA	saveas_canvas, COMMON, NOINIT
	%	320
	EXPORT	saveas_filename
saveas_filename
saveas_text
	%	256
saveas_lasthandler
	%	4
saveas_handler
	%	4
saveas_size
	%	4
saveas_type
	%	4
saveas_list
	%	4
saveas_offset
	%	4
saveas_sprite
	%	12
saveas_clickhandler
	%	4

	IMPORT	canvas_createallocated
	IMPORT	canvas_addhandler
	IMPORT	poll_lastevent
	IMPORT	poll_block
	IMPORT	canvas_make
	IMPORT	canvas_setflags

	AREA	|____saveas_sticky|, CODE, READONLY
	EXPORT	saveas_sticky
saveas_sticky

	STMFD	r13!,{r4,r5}
	MOV	r4,#&2000
	LDR	r5,=poll_lastevent
	STR	r4,[r5]
	LDMFD	r13!,{r4,r5}
	B	saveas

	AREA	|____saveas|, CODE, READONLY
	EXPORT	saveas
saveas

	MOV	r12,r13
	STMFD	r13!,{r4-r8,lr}
	LDR	r4,=poll_lastevent
	LDR	r4,[r4]
	LDR	r5,=saveas_stickyfield
	STR	r4,[r5]
	LDR	r4,=|_3dstatus|
	LDR	r4,[r4]
	TEQ	r4,#0
	BEQ	sas_skip3d
	STMFD	r13!,{r0-r3}
	BL	saveas_make3d
	LDMFD	r13!,{r0-r3}
sas_skip3d
	LDR	r6,[r12]
	CMP	r6,#&8000
	BGT	saveas_oldstyle
	TEQ	r6,#0
	MOVNE	r6,r12
saveas_oldstyle
	LDR	r4,=saveas_size
	STR	r1,[r4,#4]
	STR	r2,[r4]
	LDR	r2,[r4,#8]
	STR	r3,[r4,#-4]
	TEQ	r6,#0
	ADREQ	r6,saveas_null_list
	TEQ	r6,r2
	BEQ	saveas_notnew
	MOV	r7,r1
	STR	r6,[r4,#8]
	LDR	r1,=saveas_canvas
	LDR	r5,[r1,#window_handle]
	TEQ	r5,#0
	BEQ	saveas_notnew2
	MOV	r5,r0
	MOV	r8,r3
	MOV	r0,r1
	IMPORT	canvas_removeallocated
	BL	canvas_removeallocated
	LDR	r1,=saveas_canvas
	MOV	r0,#0
	STR	r0,[r1,#window_handle]
	MOV	r0,r5
	MOV	r3,r8
saveas_notnew2
	MOV	r1,r7
saveas_notnew
	LDR	r4,[r6]
	ADD	r4,r4,r4,LSL#1
	MOV	r4,r4,LSL#4				; x48
	LDR	r2,=saveas_offset
	STR	r4,[r2]
	LDR	r5,=saveas_text
saveas_copytext
	LDRB	r6,[r0],#1
	STRB	r6,[r5],#1
	CMP	r6,#32
	BGT	saveas_copytext
	MOV	r6,#0
	STRB	r6,[r5,#-1]
	MOV	r0,r1
	BL	saveas_setfiletype
	LDR	r5,=saveas_canvas
	LDR	r4,[r5,#window_handle]
	TEQ	r4,#0
	BNE	saveas_icon
	MOV	r3,r5
	MOV	r0,#320
	LDR	r1,=saveas_offset
	LDR	r1,[r1]
	ADD	r1,r1,#216
	ADR	r2,saveastxt
	BL	canvas_createallocated
	MOV	r0,r5
	MOV	r1,#3<<24
	MOV	r2,#0
	BL	canvas_setflags
	MOV	r1,#2
	STRB	r1,[r5,#window+38]
	BL	canvas_make
	MOV	r0,r5
	MOV	r1,#CANVAS_CLICKHANDLER
	ADRL	r2,saveas_click
	IMPORT	canvas_addhandler
	BL	canvas_addhandler
	MOV	r6,#4				; Should be 4
	ADR	r7,saveas_icons
	MOV	r0,r5
	MOV	r1,#CANVAS_KEYHANDLER
	ADRL	r2,saveas_key
	BL	canvas_addhandler
	SUB	r13,r13,#12
	LDR	r4,=saveas_offset
	LDR	r4,[r4]
	LDR	r8,=saveas_iconflag
	LDR	r8,[r8]
saveas_makeicons
	LDMIA	r7!,{r1-r3}
	LDR	lr,[r3,#4]			; Read validation string
	CMP	lr,#-1
	LDRNEB	lr,[lr,#-1]			; If it exists, read the expansion size of the icon
	MOVNE	lr,lr,LSL#24
	MOVEQ	lr,#0
	CMP	r1,#72
	ADDGE	r1,r1,r4			; Add in the offset
	ADD	r1,r1,lr,ASR#24
	TEQ	r2,#0				; Is it the 'Save' or 'Cancel' icons?
	MOVEQ	r2,r8				; Nope, so give it one
	STMIA	r13,{r1-r3}
	LDMIA	r7!,{r1-r3}
	SUB	r1,r1,lr,ASR#24
	SUB	r2,r2,lr,ASR#24
	ADD	r3,r3,lr,ASR#24			; Expand the icon (if necessary)
	CMP	r2,#72
	ADDGE	r2,r2,r4			; Add in the offset
	MOV	r0,r5
	BL	icon_createforgetful
	SUBS	r6,r6,#1
	BGT	saveas_makeicons
	CMP	r4,#0
	BEQ	saveas_noopts
;	ADD	r4,r4,#136
	LDR	r7,=saveas_list
	LDR	r7,[r7]
	LDR	r1,[r7,#4]
	LDR	r6,=saveas_clickhandler
	STR	r1,[r6]
	ADD	r7,r7,#8
saveas_optloop
	LDR	r1,[r7],#4
	LDRB	r6,[r1],#1
	ANDS	r6,r6,#15
	LDR	r2,optflags
	ORR	r2,r2,r6,LSL#16					; Set ESG flag from first byte
	LDREQ	r3,=saveas_ticon
	LDRNE	r3,=saveas_uicon
	STR	r1,[r3]
	SUB	r1,r4,#48+20-136
	STMIA	r13,{r1-r3}
	MOV	r1,#12
	SUB	r2,r4,#96+20-136
	MOV	r3,#320-12
	MOV	r0,r5
	BL	icon_createforgetful
	SUBS	r4,r4,#48
;	CMP	r4,#136
	BGT	saveas_optloop
saveas_noopts
	ADD	r13,r13,#12
saveas_icon
	LDR	r0,=poll_lastevent
	LDR	r0,[r0]
	TEQ	r0,#17
	BNE	saveas_menu
	LDR	r0,=poll_block
	LDR	r0,[r0,#16]
	EOR	r0,r0,#&40000
	TEQ	r0,#&c0
	BNE	saveas_menu
	MOV	r0,r5
	IMPORT	menu_displaysubcanvas
	BL	menu_displaysubcanvas
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]
saveas_menu
	TEQ	r0,#&2000			; This is a special bit
	BEQ	saveas_stickybit
	MOV	r0,r5
	IMPORT	menu_displaycanvas
	BL	menu_displaycanvas
	MOV	r0,r5
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]
saveas_stickybit
	SWI	XOS_Mouse
	LDR	r3,=saveas_offset
	LDR	r3,[r3]
	ADD	r3,r3,#216
	SUB	r2,r1,r3
	SUB	r1,r0,#64
	MOV	r0,r5
	IMPORT	canvas_opentop
	BL	canvas_opentop
	MOV	r0,r5
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]

saveas_null_list
	DCD	0


saveas_defsprite
	=	0,"Sfile_",0,0,0
	=	0,0,0,0
	ALIGN

	EXPORT	saveas_spritename
saveas_spritename *	saveas_defsprite+2

saveastxt
	=	"Save as:",0
	ALIGN

saveas_icons
; Format is : MAXY,FLAGS,ICON_DATA *,MINX,MINY,MAXX

	DCD	60,0,saveas_cancel
	DCD	12,12,160-8
	DCD	60,0,saveas_save
	DCD	160+8,12,320-12
	DCD	120,&0700f13d,saveas_file
	DCD	32,72,320-32
	DCD	216-12,&1700313b,saveas_sprited
	DCD	160-36,216-12-68,160+36

saveas_save
	DCD	saveas_savetxt,saveas_savevalidtxt+1,12
saveas_cancel
	DCD	saveas_canceltxt,saveas_cancelvalidtxt+1,12
saveas_file
	DCD	saveas_text,saveas_filevalid+1,256
saveas_sprited
	DCD	saveas_null_list,saveas_sprite+1,12
optflags
	DCD	&1700b113

	LTORG

saveas_click
	LDR	r0,[r1,#16]
	TEQ	r0,#0
	BEQ	saveas_closemenu
	TEQ	r0,#1
	BEQ	saveas_dosave
	TEQ	r0,#3
	BEQ	saveas_dodrag
	SUBS	r0,r0,#4
 [ arm32
	MOVLT	pc,lr
 |
	MOVLTS	pc,lr
 ]
	LDR	r1,=saveas_clickhandler
	LDR	r1,[r1]
	TEQ	r1,#0
	MOVNE	pc,r1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

saveas_flashicon
	LDR	r1,=saveas_canvas
	STR	r0,[r1,#window+4]
	LDR	r0,[r1,#window_handle]
	STR	r0,[r1,#window]!
	MOV	r0,#1<<21
	STR	r0,[r1,#8]
	STR	r0,[r1,#12]
	SWI	XWimp_SetIconState
	MOV	r3,r1
	MOV	r0,#19
	SWI	XOS_Byte
	MOV	r0,#0
	MOV	r1,r3
	STR	r0,[r1,#8]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

saveas_closemenusp
	STMFD	r13!,{lr}
	MOV	r0,#0
	BL	saveas_flashicon
	LDMFD	r13!,{lr}

saveas_closemenu
	MOV	r1,#-1
	SWI	XWimp_CreateMenu
	STMFD	r13!,{lr}
	LDR	r0,=saveas_stickyfield
	LDR	r0,[r0]
	TEQ	r0,#&2000
 [ arm32
	LDMNEFD	r13!,{pc}
 |
	LDMNEFD	r13!,{pc}^
 ]
	LDR	r0,=saveas_canvas
	IMPORT	canvas_close
	BL	canvas_close
	MOV	r0,#0
	LDR	r1,=saveas_handler
	LDR	r1,[r1]
	LDMFD	r13!,{lr}
	MOV	pc,r1

saveas_key
	LDR	r0,[r1,#24]
	TEQ	r0,#&1b						; ESCAPE
	BEQ	saveas_closemenusp
	TEQ	r0,#13
	BEQ	saveas_dosavesp					; RETURN
	CMP	r0,#&180					; Is it a special key?
	SWILT	XWimp_ProcessKey
 [ arm32
	MOVLT	pc,lr
 |
	MOVLTS	pc,lr
 ]
	SUB	r2,r0,#&180
	TEQ	r2,#1						; F1 (CANCEL)
	TEQNE	r2,#2						; F2 (SAVE)
	TEQNE	r2,#3						; F3 (SAVE)
	SWINE	XWimp_ProcessKey
 [ arm32
	MOVNE	pc,lr
 |
	MOVNES	pc,lr
 ]
	SUBS	r2,r2,#1					; Is it cancel?
	BEQ	saveas_closemenusp

saveas_dosavesp
	STMFD	r13!,{lr}
	MOV	r0,#1
	BL	saveas_flashicon
	LDMFD	r13!,{lr}

saveas_dosave
	LDR	r2,=saveas_text
	MOV	r0,r2
saveas_checkdot
	LDRB	r1,[r2],#1
	TEQ	r1,#0
	BEQ	saveas_badsave
	TEQ	r1,#'.'
	BNE	saveas_checkdot
saveas_dothesave
	STMFD	r13!,{r0,r4,r5,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	BVS	saveas_errorsave
	LDMFD	r13!,{r0,r4,r5}
	LDR	r1,=saveas_handler
	MOV	lr,pc
	LDR	pc,[r1]
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDR	r1,=poll_lastevent
	LDR	r2,[r1],#4
	TEQ	r2,#17
	TEQNE	r2,#18
	BNE	saveas_closedown
	LDR	r2,[r1,#16]
	TEQ	r2,#2
	BNE	saveas_closedown
	MOV	r2,#3
	STR	r2,[r1,#16]
	LDR	r2,[r1,#8]
	STR	r2,[r1,#12]
	MOV	r0,#17
	LDR	r2,[r1,#20]
	LDR	r3,[r1,#24]
	SWI	XWimp_SendMessage
	EXPORT	saveas_closedown
saveas_closedown
	MOV	r1,#-1
	SWI	XWimp_CreateMenu
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]
saveas_errorsave
	MOV	r1,#1
;	MOV	r3,#0
	IMPORT	|__main_taskname|
	LDR	r2,=|__main_taskname|
	SWI	XWimp_ReportError
;	IMPORT	new_errorbox
;	BL	new_errorbox
 [ arm32
	LDMFD	r13!,{r0,r4,r5,pc}
 |
	LDMFD	r13!,{r0,r4,r5,pc}^
 ]

saveas_badsave
	LDR	r0,=saveas_badsavetxt
	MOV	r1,#0
	IMPORT	simple_warning
	B	simple_warning

saveas_dodrag
	STMFD	r13!,{lr}
	IMPORT	get_dragstatus
	BL	get_dragstatus
	TEQ	r0,#0
	BNE	saveas_dragsprite
	LDR	r0,=saveas_canvas
	MOV	r1,#3
	ADR	r2,saveas_donedrag
	BL	drag_outlineicon
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

saveas_dragsprite
	LDR	r0,=saveas_canvas
	MOV	r1,#3
	ADR	r2,saveas_donedrag
	BL	drag_spriteicon
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

saveas_donedrag
	STMFD	r13!,{r4-r7,lr}
	ADR	r1,saveas_saving
	MOV	r0,#handler_saveack
	BL	main_addhandler
	LDR	r1,=saveas_canvas
	ADD	r1,r1,#window
	SWI	XWimp_GetPointerInfo
	LDMIA	r1,{r4,r5}
	LDR	r0,=saveas_text
	MOV	r2,r0
saveas_findleaf
	LDRB	r3,[r0],#1
	TEQ	r3,#'.'
	MOVEQ	r2,r0
	TEQ	r3,#0
	BNE	saveas_findleaf
	LDR	r0,[r1,#12]
	LDR	r3,[r1,#16]
	ADD	r7,r1,#20
	STMIA	r7!,{r0,r3,r4,r5}
	LDR	r4,=saveas_size
	LDMIA	r4,{r4,r5}
	STMIA	r7!,{r4,r5}
saveas_copyleafname
	LDRB	r0,[r2],#1
	STRB	r0,[r7],#1
	CMP	r0,#0
	BNE	saveas_copyleafname
	SUB	r7,r7,r1
	ADD	r7,r7,#3
	BIC	r0,r7,#3
	MOV	r2,#0			; task
	MOV	r3,#0			; my_ref
	MOV	r4,#0			; your_ref
	MOV	r5,#1
	STMIA	r1,{r0,r2-r5}
	MOV	r0,#17			; wimp_ESEND
	LDR	r2,[r1,#20]
	LDR	r3,[r1,#24]
	SWI	XWimp_SendMessage	; And send it
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	LTORG

saveas_saving
	ADD	r0,r1,#44
	B	saveas_dothesave

saveas_setfiletype
	STMFD	r13!,{r4-r6,lr}
	LDR	r4,=saveas_sprite
	CMP	r0,#&8000
	BGT	saveas_ftcopy
	ADR	r1,saveas_defsprite
	LDMIA	r1,{r1-r3}
	STMIA	r4,{r1-r3}
	TEQ	r0,#&2000
	ADREQ	r0,saveas_application
	TEQ	r0,#&1000
	ADREQ	r0,saveas_directory
	CMP	r0,#-1
	ADREQ	r0,saveas_untyped
	CMP	r0,#&1000
	BCS	saveas_ftcopy
	AND	r1,r0,#&f
	CMP	r1,#10
	ADDGE	r1,r1,#55
	ADDLT	r1,r1,#48
	STRB	r1,[r4,#9]
	MOV	r1,r0,LSR#4
	AND	r1,r1,#&f
	CMP	r1,#10
	ADDGE	r1,r1,#55
	ADDLT	r1,r1,#48
	STRB	r1,[r4,#8]
	MOV	r1,r0,LSR#8
	AND	r1,r1,#&f
	CMP	r1,#10
	ADDGE	r1,r1,#55
	ADDLT	r1,r1,#48
	STRB	r1,[r4,#7]
	ADD	r2,r4,#2
	MOV	r0,#40
	SWI	XWimp_SpriteOp
	ADRVS	r0,saveas_untyped
 [ arm32
	LDMVCFD	r13!,{r4-r6,pc}
 |
	LDMVCFD	r13!,{r4-r6,pc}^
 ]
saveas_ftcopy
	MOV	r1,#0
	STRB	r1,[r4],#1
	MOV	r1,#'S'
	STRB	r1,[r4],#1
saveas_ftcopycopy
	LDRB	r2,[r0],#1
	STRB	r2,[r4],#1
	CMP	r2,#32
	BGT	saveas_ftcopycopy
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

saveas_application
	=	"application",0
	ALIGN
saveas_directory
	=	"directory",0
	ALIGN
saveas_untyped
	=	"file_xxx",0
	ALIGN

	AREA	|____saveas_getoptionstate|, CODE, READONLY
	EXPORT	saveas_getoptionstate
saveas_getoptionstate

	LDR	r1,=saveas_canvas
	ADD	r0,r0,#4
	STR	r0,[r1,#window+4]
	LDR	r0,[r1,#window_handle]
	STR	r0,[r1,#window]!
	SWI	XWimp_GetIconState
	LDR	r0,[r1,#8+16]
	ANDS	r0,r0,#1<<21
	MOVNE	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____saveas_setoptionstate|, CODE, READONLY
	EXPORT	saveas_setoptionstate
saveas_setoptionstate

	MOVS	r2,r1
	MOVNE	r2,#1<<21
	LDR	r1,=saveas_canvas
	ADD	r0,r0,#4
	STR	r0,[r1,#window+4]
	LDR	r0,[r1,#window_handle]
	STR	r0,[r1,#window]!
	STR	r2,[r1,#8]
	MOV	r0,#1<<21
	STR	r0,[r1,#12]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____saveas_fadeoption|, CODE, READONLY
	EXPORT	saveas_fadeoption
saveas_fadeoption

	MOVS	r2,r1
	MOVNE	r2,#1<<22
	LDR	r1,=saveas_canvas
	ADD	r0,r0,#4
	STR	r0,[r1,#window+4]
	LDR	r0,[r1,#window_handle]
	STR	r0,[r1,#window]!
	STR	r2,[r1,#8]
	MOV	r0,#1<<22
	STR	r0,[r1,#12]
	SWI	XWimp_SetIconState
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____saveas_issafe|, CODE, READONLY
	EXPORT	saveas_issafe
saveas_issafe

	LDR	r1,=poll_block
	LDR	r0,[r1,#36]
	CMP	r0,#-1
	MOVNE	r0,#1
	MOVEQ	r0,#0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	LTORG

	AREA	|____saveas_changefilename|, CODE, READONLY
	EXPORT	saveas_changefilename
saveas_changefilename

	STMFD	r13!,{r4,r5,r14}
	MOV	r1,r0
	LDR	r0,=saveas_text
	IMPORT	strcpy
	BL	strcpy
;	IMPORT	strlen
;	BL	strlen
;	MOV	r5,r0
	LDR	r1,=saveas_canvas
	LDR	r2,[r1,#window_handle]
	STR	r2,[r1,#window]!
	MOV	r0,#2
	STR	r0,[r1,#4]
	MOV	r0,#0
	STR	r0,[r1,#12]
	STR	r0,[r1,#8]
	SWI	XWimp_SetIconState
;	ADD	r1,r1,#16
	SWI	XWimp_GetCaretPosition
	LDMIA	r1,{r0-r1}
	MOV	r4,#-1
	MOV	r5,#0
	SWI	XWimp_SetCaretPosition
;	LDR	r1,=saveas_canvas+window
;	SWI	XWimp_SetIconState
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	LTORG

	AREA	|____saveas_changefiletype|, CODE, READONLY
	EXPORT	saveas_changefiletype
saveas_changefiletype

	STMFD	r13!,{lr}
	BL	saveas_setfiletype
	LDR	r1,=saveas_canvas
	LDR	r2,[r1,#window_handle]
	STR	r2,[r1,#window]!
	MOV	r0,#3
	STR	r0,[r1,#4]
	MOV	r0,#0
	STR	r0,[r1,#12]
	STR	r0,[r1,#8]
	SWI	XWimp_SetIconState
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	LTORG

	AREA	|____saveas_make3d|, CODE, READONLY
	EXPORT	saveas_make3d
saveas_make3d

	LDR	r0,=saveas_iconflag
	LDR	r1,s3d_if
	STR	r1,[r0]
	ADR	r3,s3d_list
s3d_loop
	LDMIA	r3!,{r0-r2}
	TEQ	r0,#0
 [ arm32
	MOVEQ	pc,lr
 |
	MOVEQS	pc,lr
 ]
	STMIA	r2,{r0,r1}
	B	s3d_loop

s3d_if	DCD	&171f413d
s3d_list
	=	0,"r5,14",0
	ALIGN
	DCD	saveas_cancelvalidtxt
	=	8,"r6,14",0
	ALIGN
	DCD	saveas_savevalidtxt
	DCD	0,0,0

	LTORG

	AREA	|____drag_htrench|, CODE, READONLY
	EXPORT	drag_htrench
drag_htrench

; r0 is canvas
; r1 is left x
; r2 is Y coordinate
; r3 is length
;!r12 is routine to call when finished
;r12!4 is routine to call while dragging

	MOV	r12,r13
	STMFD	r13!,{r4-r6,lr}
	LDMIA	r12,{r5,r6}
	ADD	r3,r3,r1
	MOV	r4,r2
	STMFD	r13!,{r4-r6}
	BL	drag_trench
	ADD	r13,r13,#12
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____drag_trench|, CODE, READONLY
	EXPORT	drag_trench
drag_trench

; r0 is canvas
; r1 is left x
; r2 is Y coordinate
; r3 is width
; !r12 is height
; r12!4 is routine to call when finished
; r12!8 is routine to call while dragging

	MOV	r12,r13
	STMFD	r13!,{r2-r9,lr}
	LDMIA	r12,{r4,r6,r7}
;	LDR	r4,[r12]
;	LDR	r7,[r12,#8]
	LDR	r5,=|__drag_canvas|
	STMIA	r5,{r0,r7}
	MOV	r5,r1

; r2 is y0
; r3 is x1
; r4 is y1
; r5 is x0

	MOV	r7,r0
	LDR	r6,[r7,#window_handle]
	STR	r6,[r0,#window]!
	MOV	r1,r0
	SWI	XWimp_GetWindowState
	LDR	r8,[r1,#20]
	LDR	r9,[r1,#4]
	SUB	r9,r9,r8
	ADD	r3,r3,r9
	ADD	r5,r5,r9
	LDR	r8,[r1,#24]
	LDR	r9,[r1,#16]
	SUB	r9,r9,r8
	ADD	r4,r4,r9
	ADD	r2,r2,r9
;	STMFD	r13!,{r2-r5}
	ADD	r1,r1,#36
	SWI	XWimp_GetPointerInfo
	LDR	r6,[r1,#4]
	LDR	r0,[r1]
	STR	r0,[r1,#8]
	STR	r0,[r1,#16]
	STR	r6,[r1,#12]
	STR	r6,[r1,#20]
;	LDMFD	r13!,{r2-r5}
	ADD	r0,r1,#24
	STMIB	r0,{r2-r4}
	STR	r5,[r0]
	MOV	r0,#7
	STR	r0,[r1,#4]
	SWI	XWimp_DragBox
 [ arm32
	LDMVSFD	r13!,{r2-r9,pc}
 |
	LDMVSFD	r13!,{r2-r9,pc}^
 ]
	LDR	r4,=|__drag_callroutine|
	LDR	r5,[r12,#4]
	STR	r5,[r4]
	MOV	r0,#handler_drag
	LDR	r1,=drag_handler
	BL	main_addhandler
	STR	r0,[r4,#4]					; Store old handler
	LDMFD	r13!,{r2-r9,lr}
	B	drgt_setimmediate

drgt_nullroutine
	TEQ	r0,#0
	BNE	drgt_setimmediate
	STMFD	r13!,{r4,lr}
	LDR	r0,=|__drag_canvas|
	LDMIA	r0,{r1,r4}
	LDR	r0,[r1,#window_handle]
	STR	r0,[r1,#window]!
	SWI	XWimp_GetWindowState
	LDR	r0,[r1,#4]
	LDR	r2,[r1,#20]
	SUB	r2,r0,r2
	LDR	r0,[r1,#16]
	LDR	r3,[r1,#24]
	SUB	r3,r0,r3
	SWI	XWimp_GetPointerInfo
	LDR	r0,[r1,#8]
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}	; Released...
 |
	LDMEQFD	r13!,{r4,pc}^	; Released...
 ]
	LDMIA	r1,{r0,r1}
	SUB	r0,r0,r2
	SUB	r1,r1,r3
	TEQ	r4,#0
	MOV	lr,pc
	MOVNE	pc,r4
	LDMFD	r13!,{r4,lr}
drgt_setimmediate
	ADR	r1,drgt_nullroutine
	MOV	r0,#handler_immediate
	B	main_addhandler

	AREA	|____drag_sprite|, CODE
	EXPORT	drag_sprite
drag_sprite

; r0 is ^ area
; r1 is ^ sprite
; r2 is screen, or not screen
; r3 is end routine

	MOV	r12,r3
	STMFD	r13!,{r4-r7,lr}
	MOV	r4,r0
	MOV	r5,r1
	MOV	r6,r2
	SWI	XOS_Mouse
	LDR	r2,=box
	SUB	r0,r0,#34
	SUB	r1,r1,#34
	STMIA	r2!,{r0,r1}
	ADD	r0,r0,#68
	ADD	r1,r1,#68
	STMIA	r2!,{r0,r1}
	SUB	r3,r2,#16
	MOV	r1,r4
	MOV	r2,r5
	TEQ	r6,#0
	MOVEQ	r0,#2_11010101
	MOVNE	r0,#2_10000101
;	ADR	r4,box2
;	LDR	r5,=draw_maxx
;	LDMIA	r5,{r7,lr}
;	MOV	r5,#0
;	MOV	r6,#0
;	STMIA	r4,{r5-r7,lr}
	SWI	XDragASprite_Start
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4-r7,pc}
 |
	LDMVSFD	r13!,{r4-r7,pc}^
 ]
	MOV	r0,#handler_drag
	MOV	r1,r12
	BL	main_addhandler
	MOV	r0,#1
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	LTORG

	EXPORT	drag_spritestop

drag_spritestop
	SWI	XDragASprite_Stop
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

box	%	16
;box2	%	16

	END
